<template>
  <div class="container-scroller">
   <site-header></site-header>
    <!-- partial -->
    <div class="container-fluid page-body-wrapper">
      <div class="row row-offcanvas row-offcanvas-right">
        <!-- partial:partials/_sidebar.html -->
        <sidebar></sidebar>
        <!-- partial -->
        <div class="content-wrapper">
          <router-view></router-view>
        </div>
        <site-footer></site-footer>
      </div>
      <!-- row-offcanvas ends -->
    </div>

</div>
</template>
<script>
import siteHeader from './view/site-header/index.vue'
import sidebar from './view/sidebar/index.vue'
import siteFooter from './view/site-footer/index.vue'
import Echo from 'laravel-echo'
import {
  ls
} from './services/ls.js'
import {
  socket
} from './services/socket.js'
import {
  event,forceReloadWindow
} from './utils'
import {store} from './stores/store'

export default {
  components: {
    siteHeader,
    siteFooter,
    sidebar
  },
  data() {
    return {
      authenticated: false,
    }
  },
  mounted() {
    const token = ls.get('jwt-token')

    if (token) {
      this.authenticated = true
      this.init()
      
    }
  },
  created() {
    event.on({
      /**
       * Shows the "Edit Song" form.
       *
       * @param {Array.<Object>} An array of songs to edit
       */
      'athu:login': songs => this.$refs.editSongsForm.open(songs),

      /**
       * Log the current user out and reset the application state.
       */
      async logout () {
        await userStore.logout()
        ls.remove('jwt-token')
        forceReloadWindow()
      },

      /**
       * Init our basic, custom router on ready to determine app state.
       */
      'koel:ready': () => {
        router.init()
      }
    })

  },
  methods: {
    async init () { 
      await socket.init()

      // Make the most important HTTP request to get all necessary data from the server.
      // Afterwards, init all mandatory stores and services.
      try {

        // Let all other components know we're ready.
        event.emit('app:ready')
      } catch (err) {
        this.authenticated = false
      }
    },
    OnLogout: function () {
        this.$store.dispatch('logout')
        .then(() => {
          this.$router.push('/login')
        })
      },
    OnUserLoggedIn() {
      this.authenticated = true;
      this.user = this.$store.state.user;
    },
  },
  computed:{
     isLoggedIn : function(){ return this.$store.getters.isLoggedIn}
  }


}

</script>
